package com.insomnia.GUI;
import com.insomnia.parser.RequestData;
import com.insomnia.parser.RequestLoader;
import com.insomnia.parser.ResponseData;
import com.insomnia.parser.Saver;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.text.Utilities;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.DataInput;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;

public class RequestPanel extends JPanel {
    private VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    private String[] ss = {"Form Data","JSON","Binary Data"};
    private JComboBox Json_FormData = new JComboBox(ss);
    private JPanel body_pane = new JPanel(){
        @Override
        public Dimension getPreferredSize(){
            return body.getSize();
        }
    };
    private JPanel body = new JPanel();
    private JPanel auth = new JPanel();
    private JPanel query = new JPanel();
    private JPanel mainCenterHeader = new JPanel(vfLayout);
    private JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
    private HashMap<String , String> headers_values= new HashMap<>();
    private JPanel docs = new JPanel();
    private JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();
    private JTextField headerField = new JTextField("header");
    private JTextField valueField = new JTextField("value");
    private JCheckBox checkBox = new JCheckBox();
    private JButton delete = new JButton();
    private JPanel rightOfHeader = new JPanel();
    private JPanel center_header = new JPanel(new GridLayout(1,2));
    private JPanel header = new JPanel(new BorderLayout());
    private String s []={"Patch","Put","Post","Delete","Get"};
    private JComboBox centerMenu = new JComboBox(s);
    private JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");
    private JButton sendButton = new JButton("send");
    private JPanel centerUp = new JPanel(new BorderLayout());

    public JTabbedPane tabbedPaneCenterRequest() throws IOException {
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        BufferedImage master;
        master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
        Image scaled = master.getScaledInstance(20,20, java.awt.Image.SCALE_SMOOTH);

        body.setBackground(Color.GRAY);
        body.add(Json_FormData,BorderLayout.NORTH);
        body.add(body_pane);
        Json_FormData.setSelectedIndex(0);
        initBody();
        Json_FormData.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                initBody();
            }
        });
        auth.setBackground(Color.GRAY);
        query.setBackground(Color.GRAY);
        mainCenterHeader.setBackground(Color.GRAY);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        docs.setBackground(Color.GRAY);
        //request-center
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);

        MouseAdapter deleteClick = new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JButton Btn = (JButton) e.getSource();
                //to repair showing
                mainCenterHeader.remove(((JPanel) Btn.getParent()).getParent());
                mainCenterHeader.revalidate();
                mainCenterHeader.repaint();
            }
        };

        delete.addMouseListener(deleteClick);
        MouseAdapter m = new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if (e!=null && !isLastComponent(((Component) e.getSource()).getParent().getParent())) return;
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.addMouseListener(this);
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                newCheckBox.setSelected(true);
                JButton newDelete = new JButton();
                newDelete.setPreferredSize(new Dimension(20,20));
                newDelete.setIcon(new ImageIcon(scaled));
                newDelete.addMouseListener(deleteClick);
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader );
                mainCenterHeader.validate();
            }
        };

        mainCenterHeader.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (mainCenterHeader.getComponentCount()==0) m.mouseClicked(null);
            }
        });

        body_pane.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (((JPanel) body_pane.getComponent(0)).getComponentCount()==0 && body_insert!=null && selectedItem==0) body_insert.mouseClicked(null);
            }
        });

        headerField.addMouseListener(m);


        headerField.setFocusable(true);
        headerField.setBorder(border);
        valueField.setBorder(border);
        delete.setIcon(new ImageIcon(scaled));
        delete.setPreferredSize(new Dimension(20,20));
        checkBox.setSelected(true);
        rightOfHeader.add(checkBox);
        rightOfHeader.add(delete);
        center_header.add(headerField);
        center_header.add(valueField);
        header.add(rightOfHeader,BorderLayout.EAST);
        header.add(center_header,BorderLayout.CENTER);
        mainCenterHeader.add(header);
        return tabbedPaneCenterRequest;
    }


    boolean isLastComponent(Component c){
        return isLastComponent(c,mainCenterHeader);
    }

    boolean isLastComponent(Component c,JPanel p){
        return p.getComponent(p.getComponentCount()-1)==c;
    }

    public HashMap<String,String> getHeaders(){
        HashMap<String,String> headers = new HashMap<>();
        for(Component c : mainCenterHeader.getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel r = (JPanel)nh.getComponent(0), l = (JPanel) nh.getComponent(1);
                JCheckBox cb = (JCheckBox) r.getComponent(0);
                if (cb.isSelected()){
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (!h.getText().trim().isEmpty()){
                        headers.put(h.getText().trim(),v.getText());
                    }
                }
            }
        }
        return headers;
    }

    public HashMap<String,String> getFormDataBody(){
        HashMap<String,String> bodydata = new HashMap<>();
        for(Component c : ((JPanel)body_pane.getComponent(0)).getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel l = (JPanel) nh.getComponent(1);
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (!h.getText().trim().isEmpty()){
                        bodydata.put(h.getText().trim(),v.getText());
                    }
            }
        }
        return bodydata;
    }

    public String getFormDataBodyAsString(){
        HashMap<String,String> b = getFormDataBody();
        if(b.size()==0) return "";
        String f = "";
        for (String key : b.keySet()){
            f = f+key+"="+b.get(key)+"&";
        }
        return f.substring(0,f.length()-1);
    }

    int selectedItem = -2;
    MouseAdapter body_insert = null;
    void initBody(){
        if (selectedItem == Json_FormData.getSelectedIndex()) return;
        selectedItem = Json_FormData.getSelectedIndex();

        if(body_pane.getComponentCount()>0) {
            Component[] components = body_pane.getComponents();
            for(Component c : components) body_pane.remove(c);
        }

        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        if(Json_FormData.getSelectedItem().equals("JSON")) {
            JTextArea textArea = new JTextArea(){
                @Override
                public Dimension getPreferredSize(){
                    return body_pane.getSize();
                }
            };
            textArea.setToolTipText("Enter JSON");
            textArea.setBorder(border);
            body_pane.add(textArea);
        } else if(Json_FormData.getSelectedItem().equals("Binary Data")){
            JTextField path = new JTextField("File Path"){
                @Override
                public Dimension getPreferredSize(){
                    return new Dimension(body_pane.getSize().width-16,28);
                }
            };
            path.setBorder(border);
            body_pane.add(path,BorderLayout.NORTH);

            JButton selector = new JButton("Choose File");
            body_pane.add(selector,BorderLayout.NORTH);
            selector.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    super.mouseClicked(e);
                    FileDialog fc = new FileDialog((Frame) null,"Select a file to upload");
                    fc.setMode(FileDialog.LOAD);
                    fc.setVisible(true);
                    String f = fc.getFile();
                    if (f!=null && !f.isEmpty()) {
                        path.setText(new File(fc.getDirectory(),fc.getName()).getAbsolutePath());
                    }
                }
            });
        }else {
            BufferedImage master = null;
            try {
                master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
            } catch (IOException e) {
            }
            final Image scaled = master.getScaledInstance(20, 20, java.awt.Image.SCALE_SMOOTH);

            final JPanel vl = new JPanel(vfLayout) {
                @Override
                public Dimension getPreferredSize() {
                    return body_pane.getSize();
                }
            };
            body_pane.add(vl);

            if (body_insert==null){
                MouseAdapter deleteClick = new MouseAdapter() {
                    @Override
                    public void mouseClicked(MouseEvent e) {
                        JButton Btn = (JButton) e.getSource();
                        //to repair showing
                        vl.remove(((JPanel) Btn.getParent()).getParent());
                        vl.revalidate();
                        vl.repaint();
                    }
                };

            body_insert = new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    if (e != null && !isLastComponent(((Component) e.getSource()).getParent().getParent(), vl)) return;
                    JTextField newHeaderField = new JTextField("key");
                    newHeaderField.addMouseListener(this);
                    newHeaderField.setBorder(border);
                    JTextField newValueField = new JTextField("value");
                    newValueField.setBorder(border);

                    JButton newDelete = new JButton();
                    newDelete.setPreferredSize(new Dimension(20, 20));
                    newDelete.setIcon(new ImageIcon(scaled));
                    newDelete.addMouseListener(deleteClick);
                    JPanel newRightOfHeader = new JPanel();

                    newRightOfHeader.add(newDelete);
                    JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                    new_center_header.add(newHeaderField);
                    new_center_header.add(newValueField);
                    JPanel newHeader = new JPanel(new BorderLayout());
                    newHeader.add(newRightOfHeader, BorderLayout.EAST);
                    newHeader.add(new_center_header, BorderLayout.CENTER);
                    vl.add(newHeader);
                    vl.validate();
                }
            };
        }
            body_insert.mouseClicked(null);
        }

        body_pane.revalidate();
        body_pane.repaint();
    }

    //request_up
    public JPanel centerUp(){
        sendButton.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                RequestData requestData = new RequestData();
                requestData.setUrl(URLTextField.getText());
                super.mouseClicked(e);
                Saver saver = new Saver();
                //set if it is Json or not
                if(Json_FormData.getSelectedItem().equals("JSON")) {
                    requestData.setJson(true);
                    JTextArea textArea = (JTextArea) body_pane.getComponent(0);
                    requestData.setBody(textArea.getText().trim());
                }
                else if(Json_FormData.getSelectedItem().equals("Binary Data")){
                    JTextField p = (JTextField) body_pane.getComponent(0);
                    if (!p.getText().isEmpty() && !p.getText().equals("File Path"))
                   requestData.setUploadPath(p.getText());
                }else {
                    requestData.setBody(getFormDataBodyAsString());
                }

                requestData.setHeaders(getHeaders());
                requestData.setFollowRedirects(true);
                requestData.setShowResponseHeaders(true);
                requestData.setSaveRequest(false);

                ResponseData data = RequestLoader.run(requestData);

                if (data.hasSyntaxError()){
                    System.out.println("Syntax Error : "+data.getSyntaxErrorLog());
                }else{
                    System.out.println("Connection time : "+((data.getFinalTime()-data.getStartTime())/1000)+"s");
                    System.out.println("Response Status : "+ data.getResponseStatus());

                    if (data.isSuccessful()){
                        System.out.println("Response : "+data.getResponseString());

                        if (data.getRequestData().isShowResponseHeaders()&& data.getResponseHeaders()!=null){
                            System.out.println("******* Response Headers *******");
                            for (String key : data.getResponseHeaders().keySet()){
                                System.out.println(key+" : "+data.getResponseHeaders().get(key).toString());
                            }
                        }
                    }else {
                        System.out.println("Error : "+data.getErrorMessage());
                    }
                }
            }
        });


        centerMenu.setFont(new Font("Arial",20,15 ));
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);
        return centerUp;
    }



    public void createRequestPanel() throws IOException {
        addToMainRequestPanel(centerUp() , tabbedPaneCenterRequest());
    }

    public void addToMainRequestPanel(JPanel centerUp ,JTabbedPane tabbedPaneCenterRequest ){
        this.setLayout(new BorderLayout());
        this.add(centerUp,BorderLayout.NORTH);
        this.add(tabbedPaneCenterRequest , BorderLayout.CENTER);
    }


    public JPanel getRightOfHeader() {
        return rightOfHeader;
    }

    public JPanel getCenter_header() {
        return center_header;
    }

    public JPanel getBody() {
        return body;
    }


    public JPanel getMainCenterHeader() {
        return mainCenterHeader;
    }

    public JScrollPane getScrollPane_Header_Request() {
        return scrollPane_Header_Request;
    }

    public JPanel getDocs() {
        return docs;
    }

    public JTabbedPane getTabbedPaneCenterRequest() {
        return tabbedPaneCenterRequest;
    }

    public JPanel getHeader() {
        return header;
    }

    public JComboBox getCenterMenu() {
        return centerMenu;
    }

    public JPanel getCenterUp() {
        return centerUp;
    }
}
