/**
 * ResponseData represents a class
 */
package com.insomnia.parser;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;
import java.util.Map;

public class ResponseData {

    private RequestData requestData;
    private long startTime,finalTime;
    private boolean syntaxError = false;
    private String syntaxErrorLog = "";
    private boolean successful = false;
    private int status = -1;
    private InputStream inputStream = null;
    private Map<String, List<String>> responseHeaders;
    private String errorMessage = "";

    public ResponseData (RequestData data){
        this.requestData = data;
        startTime = System.currentTimeMillis();
    }

    public ResponseData finish(){
        finalTime = System.currentTimeMillis();
        return this;
    }

    public int getStatus() {
        return status;
    }

    public void setResponseHeaders(Map<String, List<String>> responseHeaders) {
        this.responseHeaders = responseHeaders;
    }

    public void setSuccessful(boolean successful) {
        this.successful = successful;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public String getSyntaxErrorLog() {
        return syntaxErrorLog;
    }

    public RequestData getRequestData() {
        return requestData;
    }

    public Map<String, List<String>> getResponseHeaders() {
        return responseHeaders;
    }

    public boolean hasSyntaxError() {
        return syntaxError;
    }

    public int getResponseStatus() {
        return status;
    }

    public long getFinalTime() {
        return finalTime;
    }

    public long getStartTime() {
        return startTime;
    }

    public boolean isSuccessful() {
        return successful;
    }

    String res = "";

    public String getResponseString(){
        return res;
    }

     String convertStreamToString(InputStream is,boolean close) {
        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        StringBuilder sb = new StringBuilder();

        String line ;
        try {
            while ((line = reader.readLine()) != null) {
                sb.append(line);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (close) {
                try {
                    is.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return sb.toString();
    }


    public void setSyntaxError(boolean syntaxError) {
        this.syntaxError = syntaxError;
    }

    public void setSyntaxErrorLog(String syntaxErrorLog) {
        this.syntaxErrorLog = syntaxErrorLog;
    }



    public InputStream getInputStream() {
        return inputStream;
    }

    public void setInputStream(InputStream inputStream) {
        this.inputStream = inputStream;
    }


    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public void setStatus(int status) {
        this.status = status;
    }
}
